<template>
	<div v-if="hasPagination || hasPlayPause || hasTabNavigation" :class="hasPagination ? $style.wrapper : ''">
		<MoleculeCarouselPagination
			v-if="hasPagination"
			:class="$style['control-item']"
			:number-of-slides="numberOfSlides"
			:current-slide="currentSlide"
			:get-slide-title="getSlideTitle"
			@switchslide="switchSlide"
		/>

		<MoleculeCarouselTabNavigation
			v-if="hasTabNavigation"
			:class="$style['control-item']"
			:number-of-slides="numberOfSlides"
			:current-slide="currentSlide"
			:get-slide-title="getSlideTitle"
			:tab-items="tabItems"
			@switchslide="switchSlide"
		/>

		<MoleculeCarouselPlayPause
			v-if="hasPlayPause"
			:class="$style['control-item']"
			:is-playing="isPlaying"
			@pause="pause"
			@play="play"
		/>
	</div>
</template>

<script>
import MoleculeCarouselPagination from '@components/molecule-carousel-pagination';
import MoleculeCarouselPlayPause from '@components/molecule-carousel-play-pause';
import MoleculeCarouselTabNavigation from '@components/molecule-carousel-tab-navigation';

export default {
	components: {
		MoleculeCarouselPagination,
		MoleculeCarouselPlayPause,
		MoleculeCarouselTabNavigation,
	},

	props: {
		hasPagination: {
			type: Boolean,
			required: true,
		},

		hasTabNavigation: {
			type: Boolean,
			default: false,
		},

		tabItems: {
			type: Array,
			default: () => [],
		},

		hasPlayPause: {
			type: Boolean,
			required: true,
		},

		numberOfSlides: {
			type: Number,
			required: true,
		},

		currentSlide: {
			type: Number,
			required: true,
		},

		getSlideTitle: {
			type: Function,
			required: true,
		},

		isPlaying: {
			type: Boolean,
			required: true,
		},
	},

	methods: {
		pause() {
			this.$emit('pause');
		},

		play() {
			this.$emit('play');
		},

		switchSlide(i) {
			this.$emit('switchslide', i);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.wrapper {
	margin-top: size('m') - 0.5rem;
}
</style>
